//---------------------------------------------------------------------------

#include <windows.h>



#include<string>
#include <cmath>
#include <iostream.h>
#include <windows.h>

#include"CxTranslatorEx.h"


//User defined function
const TCalc __stdcall toRad(const TCalc& x)
{
	return TCalc(x.real()*3.14/180,0);
}


int _tmain(int argc, _TCHAR* argv[])
{
        using namespace std;
	TCalc args[]={TCalc(3.6,6),TCalc(5.6,-4), TCalc(-1.5,0.33)};
	TCalc  res=0;
	
	TCalc twoPi=6.28;				//user defined const

	//Math expressions
    TCHAR *mathFunc = _T("F(x, y, z) = 3*x^2-y^2i+sqrt(toRad(45))/twoPi");
    TCHAR *mathExp = _T("3*x^2-y^2+exp(toRad(85))/4.45i+twoPi");
    TCHAR *varList = _T("x y z");


	if(!LoadCxTranslator())
        exit(1);

	try{

		AddFunction(_T("toRad"), toRad);
		AddConst(_T("twoPi"), twoPi);

	        BuildEqu(mathFunc);
		res = CalcFor(args);
		cout<<"Res="<<res<<endl;

		RemoveFunction(_T("toRad"));
		Build(_T(""), _T("twoPi/2"));
		res = CalcFor(args);
	        cout<<"Res="<<res<<endl;

		RemoveConst(_T("twoPi"));
		res=Evaluate(varList, mathExp, args); //Error.
		cout<<"Res="<<res<<endl; 

	} catch(CxException &e) {
		std::cout<<e.what().c_str();
		}

        UnLoadCxTranslator();
	return 0;
}
